#!/usr/bin/perl
use strict;
use lib ('..');
use MKDoc;
use Data::Dumper;

eval { MKDoc->process ('cgi.mkdoc') };
if (defined $@ and $@)
{
    print "Status: 500 Internal Server Error\n";
    print "Content-Type: text/html\n\n";
#    Apache sortes out the Error message, we don't need to do it 
#    ourselves
#    print error();
    if (ref $@) { $@ = Dumper ($@) }
    $@ = Dumper (\%ENV) . "\n\n" . $@;
    warn "SOFTWARE_ERROR\n\n" . $@ . "\n\n";
}

BEGIN {
    $SIG{'__WARN__'} = sub {
	warn $_[0] unless ($_[0] =~ /byte of utf8 encoded char at/);
    };
}


sub error
{
    return <<'EOF';
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xml:lang="en" lang="en" xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Internal Server Error</title>
  </head>
  <body>
    <h1>Internal Server Error</h1>
    <p>Sorry there has been a server error.</p> 
  </body>
</html>
EOF

}

1;
