# There was a bug with unicode and flo::Editor::generate_xml
# when using more than one component with unicode text
# this test checks if is works properly
use lib qw /../;
use MKDoc::Unicode;
use flo::editor::Html;
use flo::editor::File;
use flo::Editor;
use MKDoc;
use strict;
use Data::Dumper;
use utf8;

eval
{
  MKDoc::init ('cgi.mkdoc');
    
    my $utf8 = "This is a UTF-8 string: \x{E9}";
    my $editor = new flo::Editor;
    my $html = bless { data => $utf8 }, 'flo::editor::Html';
    my $file = bless { file => 'foo', title => 'bar' }, 'flo::editor::File';
    
    $editor->{block}->{1} = $html;
    $editor->{block}->{2} = $file;
    
    my $editor_xml = $editor->generate_xml;
    
    # this is equivalent to the generate_xml after it was fixed
    my $self = $editor;
    my @out  = ();
    foreach my $id (keys %{$self->{block}})
    {
	my $component = $self->{block}->{$id};
	
	# find out what the type of this component is.
	my $type  = flo::Editor::_PAM_()->{ref $component};	
	my $start = qq |<block id="flo_block_$id" type="$type">|;
	my $comp  = $component->generate_xml;
	my $stop  = qq |</block>|;
	u_mark (\$start);
	u_mark (\$comp);
	u_mark (\$stop);
	push @out, ($start, $comp, $stop);
    }
    my $editor_xml2 = join "\n", @out;
    
    die '[ flo::Editor::generate_xml ]' unless ($editor_xml eq $editor_xml2);
};

if (defined $@ and ref $@) { $@ = "\n" . Dumper ($@) . "\n" }
die $@ if (defined $@ and $@);
