#!/usr/bin/perl
use 5.6.0;
use Carp;
use lib ('..');
use flo::Standard;
use lib::Exception;
use strict;
use MKDoc::Util::Text2HTML;
use Unicode::String;

while (<STDIN>)
{
    my $data = $_;
    my %entities = $data =~ /(\&(?:\#([0-9]+)|\w+)\;)/g;
    delete $entities{'&lt;'};
    delete $entities{'&gt;'};
    delete $entities{'&amp;'};
    delete $entities{'&quot;'};
    while (my ($entity, $decimal) = each %entities)
    {
	# get the character code for this character
	if (defined $decimal and $decimal)
	{
	    my $val = chr ($decimal);
	    my $u_val = Unicode::String::latin1 ($val);
	    $val = $u_val->utf8;
	    $data =~ s/\Q$entity\E/$val/g;
	}
	else
	{
	    my $decimal = $MKDoc::Util::Text2HTML::HTML_TO_DECIMAL->{$entity};
	    if (defined $decimal and $decimal)
	    {
		my $val = chr ($decimal);
		my $u_val = Unicode::String::latin1 ($val);
		$val = $u_val->utf8;
		$data =~ s/\Q$entity\E/$val/g;
	    }
	    else
	    {
		$data =~ s/\Q$entity\E//g;
	    }
	}
    }
    print $data;
}

1;


